require "./lib/dieta/menu.rb"

# Clase que hereda de Menu y nos permite organizar menús por grupos de edad.
# @author alu0100895179
# @attr_reader [int] edad Índice para saber de que grupo de edad se trata
class Menu_edad < Menu
	
	attr_reader :edad
	
# Variable de clase para que los objetos puedan obtener mediante el índice que almacenan el texto del grupo de edad correspondiente.	
    @@grupo_edad=["4 a 8 años", "9 a 13 años", "14 a 18 años"]

# Método para crear el objeto padre y asignar los determinados valores.
# @param [char] titulo Título para el menú (ej. desayuno, almuerzo, etc.)
# @param [array] porcentaje Array con el rango de porcentajes de ingesta diaria
# @param [array] platos Array con los diferentes platos del menú con los elementos descripción, porciones e ingesta
# @param [char] vct Cadena que almacena el valor calórico total
# @param [array] porcentaje_pgh Array con los valores para los porcentajes de proteínas, grasas e hidratos respectivamente
# @param [int] edad Índice para saber de que grupo de edad se trata    
	def initialize(titulo, porcentaje, platos, vct, porcentaje_pgh, edad)
		super(titulo, porcentaje, platos, vct, porcentaje_pgh)
		@edad=edad
	end

# Método para obtener en formato texto el grupo de edad al que pertenece.
# @return [char] Devuelve la cadena correspondiente al grupo de edad	
	def get_text_edad
		@@grupo_edad[@edad]
	end

# Método para mostrar por pantalla con la nueva información
# @return [char] Devuelve la cadena correspondiente al menú formateado y mostrando también el grupo de edad	
	def to_s
	    
	    x=""
	    x+=super.to_s()
		x << "Grupo de edad: "
		x << "#{@@grupo_edad[@edad]}"
		x << ".\n"
		x
		
	end
end