require "./lib/dieta/menu.rb"

# Clase que hereda de Menu y nos permite organizar menús por grupos de alimentos.
# @author alu0100895179
# @attr_reader [int] galimentos Índice para saber de que grupo de alimentos se trata
class Menu_g_alimentos < Menu
	
	attr_reader :galimentos

# Variable de clase para que los objetos puedan obtener mediante el índice que almacenan el texto del grupo alimenticio correspondiente.	
	@@grupo_alimetos=["verduras y otras hortalizas", "leche, huevos, pescado, carne y frutos secos" , "cereales, legumbres y féculas", "frutas"]
	
# Método para crear el objeto padre y asignar los determinados valores.
# @param [char] titulo Título para el menú (ej. desayuno, almuerzo, etc.)
# @param [array] porcentaje Array con el rango de porcentajes de ingesta diaria
# @param [array] platos Array con los diferentes platos del menú con los elementos descripción, porciones e ingesta
# @param [char] vct Cadena que almacena el valor calórico total
# @param [array] porcentaje_pgh Array con los valores para los porcentajes de proteínas, grasas e hidratos respectivamente
# @param [int] galimentos Índice para saber de que grupo de alimentos se trata
	def initialize(titulo, porcentaje, platos, vct, porcentaje_pgh, galimentos)
		super(titulo, porcentaje, platos, vct, porcentaje_pgh)
		@galimentos=galimentos
	end
	
# Método para obtener en formato texto el grupo alimenticio al que pertenece.
# @return [char] Devuelve la cadena correspondiente al grupo alimenticio	
	def get_text_alimentos
		@@grupo_alimetos[@galimentos]
	end
	
# Método para mostrar por pantalla con la nueva información
# @return [char] Devuelve la cadena correspondiente al menú formateado y mostrando también el grupo alimenticio
	def to_s
	    
	    x=""
	    x+=super.to_s()
		x << "Grupo de alimentos: "
		x << "#{@@grupo_alimetos[@galimentos]}"
		x << ".\n"
		x
		
	end
end